/*
 * LimeSurvey
 * Copyright (C) 2007 The LimeSurvey Project Team / Carsten Schmitz
 * All rights reserved.
 * License: GNU/GPL License v2 or later, see LICENSE.php
 * LimeSurvey is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 * 
 * 
 * Description: Javascript file for templates. Put JS-functions for your template here.
 *  
 * 
 * $Id:$
 */


/*
 * The function focusFirst puts the Focus on the first non-hidden element in the Survey. 
 * 
 * Normally this is the first input field (the first answer).
 */
function focusFirst(Event)
{
	
	$('#limesurvey :input:visible:enabled:first').focus();

}
/*
 * The focusFirst function is added to the eventlistener, when the page is loaded.
 * 
 * This can be used to start other functions on pageload as well. Just put it inside the 'ready' function block
 */

/* Uncomment below if you want to use the focusFirst function */
/*
$(document).ready(function(){
	focusFirst();
});
*/
	
	
$(document).ready(function(){
});
	
	
// A custom plugin to add control buttons to LimeSurvey sliders
// Author - Tony Partner - partnersurveys.com
(function( $ ){

	$.fn.sliderButtons = function(options) {
	
		// The defaults, extended and modified with any passed in the function call
		var opts = $.extend( {
		downText: '-',		// Text for the "down" button
		upText: '+',		// Text for the "up" button
		scrolling: true,	// Continuous slider movement if left mouse button held down
		scrollInterval: 150,// Interval (in ms) between slider movement when button is held down
		valuePrefix: '',	// Prefix for callout
		valueSuffix: ''	// Suffix for callout
		}, options);
		
		return this.each(function(i) {
				
			var thisQuestion = $(this);
	
			// Add some classes
			$(thisQuestion).addClass('slider-button-question');		
			
			// Insert the buttons
			$('li.question-item', thisQuestion).append('<div class="slider-button-wrapper">\
															<button type="button" class="slider-button down">'+opts.downText+'</button>\
															<button type="button" class="slider-button up">'+opts.upText+'</button>\
														</div>');			
			
			// Initial button states
			function handleButtonState(slider) {
				var thisRow = $(slider).closest('li.question-item');
				var thisSliderVal = $(slider).slider('option', 'value');
				var thisSliderStep = $(slider).slider('option', 'step');
				var thisSliderMin = $(slider).slider('option', 'min');
				var thisSliderMax = $(slider).slider('option', 'max');
				$('button.slider-button', thisRow).prop('disabled', false);
				if ($(slider).slider('option', 'value') == thisSliderMin) {
					$('button.slider-button.down', thisRow).prop('disabled', true);
				}
				if ($(slider).slider('option', 'value') == thisSliderMax) {
					$('button.slider-button.up', thisRow).prop('disabled', true);
				}
			}
			$('.multinum-slider', thisQuestion).each(function(i) {
				handleButtonState(this);	
				if($(this).closest('li.question-item').find('input.text').val() != '') {
					$('.slider-callout', this).text(opts.valuePrefix+$(this).closest('li.question-item').find('input.text').val()+opts.valueSuffix);
				}
			});	
			
			// Function to handle button actions
			function handleButtons(thisButton) {
				var thisRow = $(thisButton).closest('li.question-item');
				var thisSlider = $('.multinum-slider', thisRow);
				var thisSliderStep = $(thisSlider).slider('option', 'step');
				var stepDecimals = 0;
				if(thisSliderStep.toString().indexOf('.') >= 0) {
					stepDecimals = thisSliderStep.toString().split('.')[1].length;
				}
				var thisSliderVal = Number($(thisSlider).slider('option', 'value')).toFixed(stepDecimals);
				var thisSliderMin = $(thisSlider).slider('option', 'min');
				var thisSliderMax = $(thisSlider).slider('option', 'max');
				if ($(thisButton).hasClass('down') && thisSliderVal > thisSliderMin) {
					$(thisSlider).slider('option', 'value', Number(thisSliderVal)-Number(thisSliderStep));
				}
				if ($(thisButton).hasClass('up') && thisSliderVal < thisSliderMax) {
					$(thisSlider).slider('option', 'value', Number(thisSliderVal)+Number(thisSliderStep));
				}
				var newValue = $(thisSlider).slider('option', 'value').toFixed(stepDecimals).replace(/\./, LSvar.sLEMradix);
				$('input.text', thisRow).val(newValue).triggerHandler('keyup');
				$('.slider-callout', thisSlider).text(opts.valuePrefix+newValue+opts.valueSuffix);
			}
			
			// Scrolling
			if(opts.scrolling == true) {
					
				var sliderTimeout;
				var clicker = $('button.slider-button', thisQuestion);
				var count = 0;

				$('button.slider-button', thisQuestion).mousedown(function(){
					var thisButton = $(this);
					sliderTimeout = setInterval(function(){
						handleButtons(thisButton);
					}, opts.scrollInterval);				
					return false;
				});				
				
				$(document).mouseup(function(){
					clearInterval(sliderTimeout);
					return false;
				});
				$('button.slider-button', thisQuestion).mouseout(function(){
					handleButtonState($(this).closest('li.question-item').find('.multinum-slider'));
				});
			}
			
			// Listener on the buttons
			$('button.slider-button', thisQuestion).click(function(e) {
				handleButtons(this)	;		
				handleButtonState($(this).closest('li.question-item').find('.multinum-slider'));
			});
			
			// Listener on sliders
			$('.multinum-slider', thisQuestion).on('slidestop', function( event, ui ) {
				handleButtonState(this);
			});
			
			// Listener on reset buttons
			$('.slider-reset', thisQuestion).on( "click", function( event, ui ) {
				var thisReset = $(this);
				setTimeout(function() {
					handleButtonState($(thisReset).closest('li.question-item').find('.multinum-slider'));
				}, 150);
			});
		});
	};
})( jQuery );
